/* AMX Mod X
*   Zoom Sinuous Crosshair
*
* (c) Copyright 2008 by VEN
*
* This file is provided as is (no warranties)
*
*	DESCRIPTION
*		Plugin moves crosshair sinusoidally while in zoom.
*
*	CREDITS
*		Idea/request by gOOdRich.
*
*	VERSIONS
*		0.1.0
*			- initial version
*/

#include <amxmodx>
#include <fakemeta>

#define PLUGIN_NAME "Zoom Sinuous Crosshair"
#define PLUGIN_VERSION "0.1.1.se7h"
#define PLUGIN_AUTHOR "VEN"

#define SINE_STEEP 0.01
#define SINE_FACTOR_X 0.7
#define SINE_FACTOR_Y 0.7

#define MAX_CLIETNS 32

#define GetPlayerFOV(%1) get_pdata_int(%1, 363 /* m_iFOV */)

#define FOV_NORMAL 90

new g_sine

public plugin_init() {
	register_plugin(PLUGIN_NAME, PLUGIN_VERSION, PLUGIN_AUTHOR)

	g_sine = register_cvar("amx_sine", "1")

	register_forward(FM_PlayerPreThink, "fwFMPlayerPreThinkPost", true)
}

public fwFMPlayerPreThinkPost(id) {
	if(get_pcvar_num(g_sine) && (pev(id, pev_button) & (IN_FORWARD|IN_BACK|IN_DUCK)))
		return FMRES_HANDLED

	new a,b
	new wid = get_user_weapon(id, a, b)
	if(wid == 3 || wid == 13 || wid == 18 || wid == 24)
	{
		static FovOld[MAX_CLIETNS + 1], Fov
		static Float:State, Float:Sign
		static Float:States[MAX_CLIETNS + 1] = {0.0, ...}
		static Float:Signs[MAX_CLIETNS + 1] = {1.0, ...}
		static Float:Increment0[MAX_CLIETNS + 1] = {0.0, ...}
		static Float:Increment1[MAX_CLIETNS + 1] = {0.0, ...}
		static Float:oldAngles[MAX_CLIETNS + 1][3]
	
		Fov = GetPlayerFOV(id)
		if (!(0 < Fov <= FovOld[id])) {
			States[id] = 0.0
			Signs[id] = 1.0
			Increment0[id] = 0.0
			Increment1[id] = 0.0
		}
	
		FovOld[id] = Fov
	
		if (!(0 < Fov < FOV_NORMAL))
			return FMRES_IGNORED
	
		static Float:Angles[3]

		pev(id, pev_v_angle, Angles)

		if(oldAngles[id][0] == Angles[0] && oldAngles[id][1] == Angles[1])
		{
			State = States[id]
			Sign = Signs[id]

			Angles[0] += Increment0[id]
			Angles[1] += Increment1[id]
	
			State += SINE_STEEP * Sign
			if (State > M_PI || State < -M_PI)
			{
				State = M_PI * Sign
				Sign = -Sign
			}
	
			Angles[0] -= (Increment0[id] = floatsin(State) * Sign * SINE_FACTOR_Y)
			Angles[1] -= (Increment1[id] = State * SINE_FACTOR_X)
	
			set_pev(id, pev_v_angle, Angles)
			set_pev(id, pev_angles, Angles)
			set_pev(id, pev_fixangle, true)

			States[id] = State
			Signs[id] = Sign
		}
		oldAngles[id] = Angles
	}

	return FMRES_HANDLED
}